/**
 * data-structure-typed
 *
 * @author Tyler Zeng
 * @copyright Copyright (c) 2022 Tyler Zeng <zrwusa@gmail.com>
 * @license MIT License
 */
export declare class MatrixNTI2D<V = any> {
    protected readonly _matrix: Array<Array<V>>;
    /**
     * The constructor creates a matrix with the specified number of rows and columns, and initializes all elements to a
     * given initial value or 0 if not provided.
     * @param options - An object containing the following properties:
     */
    constructor(options: {
        row: number;
        col: number;
        initialVal?: V;
    });
    toArray(): Array<Array<V>>;
}
