"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MatrixNTI2D = void 0;
/**
 * data-structure-typed
 *
 * @author Tyler Zeng
 * @copyright Copyright (c) 2022 Tyler Zeng <zrwusa@gmail.com>
 * @license MIT License
 */
// todo need to be improved
class MatrixNTI2D {
    /**
     * The constructor creates a matrix with the specified number of rows and columns, and initializes all elements to a
     * given initial value or 0 if not provided.
     * @param options - An object containing the following properties:
     */
    constructor(options) {
        const { row, col, initialVal } = options;
        this._matrix = new Array(row).fill(undefined).map(() => new Array(col).fill(initialVal || 0));
    }
    /* The `toArray` method returns the matrix as a two-dimensional array. It converts the internal representation of the
    matrix, which is an array of arrays, into a format that is more commonly used in JavaScript. */
    toArray() {
        return this._matrix;
    }
}
exports.MatrixNTI2D = MatrixNTI2D;
