"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MaxPriorityQueue = void 0;
/**
 * data-structure-typed
 *
 * @author Kirk Qi
 * @copyright Copyright (c) 2022 Kirk Qi <qilinaus@gmail.com>
 * @license MIT License
 */
const priority_queue_1 = require("./priority-queue");
class MaxPriorityQueue extends priority_queue_1.PriorityQueue {
    constructor(elements, options = {
        comparator: (a, b) => {
            if (!(typeof a === 'number' && typeof b === 'number')) {
                throw new Error('The a, b params of compare function must be number');
            }
            else {
                return b - a;
            }
        }
    }) {
        super(elements, options);
    }
}
exports.MaxPriorityQueue = MaxPriorityQueue;
